﻿Public NotInheritable Class FormMain
    Private LoadedImage As Drawing.Bitmap = Nothing
    Private MouseLocation As Drawing.PointF = Drawing.PointF.Empty
    Private MouseUpMustFollow As Boolean = False
    Private Moving As Boolean = False
    Private ZoomFactor As Double = 1.0
    Private ImageRect As Drawing.RectangleF = Drawing.RectangleF.Empty
   Private ImageLocation As Drawing.PointF = Drawing.Point.Empty
   Private _ImageFile As String = "..\..\IMG_20220820_091148.jpg"
   Private Sub ButtonStart_Click(sender As Object, e As EventArgs) Handles ButtonStart.Click
      LoadedImage = New Drawing.Bitmap(_ImageFile)
      ResizePicturebox()
   End Sub
   Private Sub ResizePicturebox()
        If LoadedImage Is Nothing Then Return

        'Width of the current picture 
        Dim Aktuelle_Breite As Integer = LoadedImage.Size.Width
        'Height of the current picture 
        Dim Aktuelle_Hoehe As Integer = LoadedImage.Size.Height
        ' possible width on Form
        Dim Moegliche_Breite As Integer = 1766
        ' possible height on Form
        Dim Moegliche_Hoehe As Integer = 1001

        If Aktuelle_Breite > Moegliche_Breite OrElse Aktuelle_Hoehe > Moegliche_Hoehe Then

            Picturebox1.SizeMode = PictureBoxSizeMode.StretchImage

            Picturebox1.Size = If(CInt(Math.Round(Aktuelle_Breite * Moegliche_Hoehe / Aktuelle_Hoehe, 0)) > Moegliche_Breite,
                    New Drawing.Size(Moegliche_Breite, CInt(Math.Round(Aktuelle_Hoehe * Moegliche_Breite / Aktuelle_Breite, 0))),
                    New Drawing.Size(CInt(Math.Round(Aktuelle_Breite * Moegliche_Hoehe / Aktuelle_Hoehe, 0)), Moegliche_Hoehe))
        Else
            Picturebox1.SizeMode = PictureBoxSizeMode.Normal
            Picturebox1.Size = New Drawing.Size(Aktuelle_Breite, Aktuelle_Hoehe)
        End If
    End Sub

    Private Sub Picturebox1_MouseDown(sender As Object, e As MouseEventArgs) Handles Picturebox1.MouseDown
        If LoadedImage Is Nothing Then Return

        If e.Button = MouseButtons.Left Then
            MouseLocation = e.Location
            ImageLocation = ImageRect.Location ' is (0 | 0) if the picture is freshly loaded 
            Me.Cursor = Cursors.NoMove2D
            MouseUpMustFollow = True
            Moving = True
            Picturebox1.Invalidate()
        End If
    End Sub

    Private Sub Picturebox1_MouseMove(sender As Object, e As MouseEventArgs) Handles Picturebox1.MouseMove
        If LoadedImage Is Nothing Then Return

        If e.Button = MouseButtons.Left Then
            'for Zoom
            ImageRect.Location = New Drawing.PointF(ImageLocation.X + (e.Location.X - MouseLocation.X),
                                                    ImageLocation.Y + (e.Location.Y - MouseLocation.Y))
            MouseUpMustFollow = True
            Moving = True
            Picturebox1.Invalidate()
            Return
        End If
    End Sub

    Private Sub Picturebox1_MouseUp(sender As Object, e As MouseEventArgs) Handles Picturebox1.MouseUp
        If LoadedImage Is Nothing Then Return

        If e.Button = MouseButtons.Left AndAlso MouseUpMustFollow Then
            Me.Cursor = Cursors.Default
            MouseUpMustFollow = False
            Moving = False
        End If
    End Sub

    Private Sub PictBox1_MouseWheel(sender As System.Object, e As MouseEventArgs) Handles Picturebox1.MouseWheel
        If LoadedImage Is Nothing Then Return

        If e.Delta > 0 Then
            ZoomFactor += (1.0 / 30.0)
            Picturebox1.Invalidate()
        Else
            If ZoomFactor > 0.0 Then
                ZoomFactor -= (1.0 / 30.0)
                Picturebox1.Invalidate()
            End If
        End If
    End Sub

    Private Sub Picturebox1_Paint(sender As Object, e As PaintEventArgs) Handles Picturebox1.Paint
        If LoadedImage Is Nothing Then Return

        Dim the_rectangle_to_be_zoomed_in_and_drawn As Drawing.RectangleF = CalculateRectangle()
        e.Graphics.DrawImage(LoadedImage, the_rectangle_to_be_zoomed_in_and_drawn)
    End Sub

    Private Function CalculateRectangle() As Drawing.RectangleF
        ImageRect.Width = Picturebox1.Width
        ImageRect.Height = Picturebox1.Height

        Dim newLocation As Drawing.PointF
        If Moving Then
            newLocation = ImageRect.Location
        Else
            newLocation = New Drawing.PointF(
                          (Picturebox1.Size.Width / 2.0F) - ImageRect.Width * CSng(ZoomFactor) / 2.0F,
                          Picturebox1.Location.Y + (Picturebox1.Size.Height / 2.0F) - ImageRect.Height * CSng(ZoomFactor) / 2.0F)
        End If

        Return New Drawing.RectangleF(newLocation,
                              New Drawing.SizeF(ImageRect.Width * CSng(ZoomFactor), ImageRect.Height * CSng(ZoomFactor)))
    End Function

   Private Sub btAnneresForm_Click(sender As Object, e As EventArgs) Handles btAnneresForm.Click
      Dim frm1 = New Form1
      frm1.PictureBox1.ImageLocation = _ImageFile
      frm1.Show()
   End Sub
End Class